// quick sort (c) Proteus
/*
	 quick .
	   . 
	         Shell .
	         .
	          	  

	    .    .
*/



#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#define SIZE 10000000	//  
#define SCALY 10000		//  
#define MIN_STEP 90	//      

int max_depth=-1;		//  (  )
int array[SIZE];

void Swap(int i1,int i2)
{
	int t=array[i1];
	array[i1]=array[i2];
	array[i2]=t;
}

//    
bool SortSimply(int up,int down) 
{
	int count; int s,n,p; const int steps[]={19,7,1,0};
	count=0;
	for(p=0; steps[p]; p++) {
		s=steps[p];
		for(n=up; n<=down-s; n++) if(array[n]>array[n+s]) Swap(n,n+s),count++;
	}
	return count==0;
}


//  
void SortQuick(int up,int down,int depth=0)
{
	if(depth>max_depth) max_depth=depth; // 
l1:
	if(up>=down) return;
#ifdef MIN_STEP
	if(down-up<MIN_STEP && SortSimply(up,down)) return;
#endif
	int up0=up; 
	int down0=down;
	int pivot=(array[up]+array[down])/2; //  array[(down+up)/2];   
	for(;;)
	{
		while(array[up  ]<pivot) up++;
		while(array[down]>pivot) down--;
		if(up>down) break;
        Swap(up++,down--);
	}
	if(up0-down<up-down0) { SortQuick(up0,down,depth+1); down=down0; goto l1;} 
	else { SortQuick(up,down0,depth+1);  up=up0; goto l1;}
}


//    
int main(int argc, char* argv[])
{
	int chc1=0,chc2=0,n;
	max_depth=-1;
	for(n=0; n<SIZE; n++) array[n]=rand()%SCALY,chc1+=array[n];
	clock_t t1=clock();
SortQuick(0,SIZE-1);
	clock_t t2=clock();
	for(n=0; n<SIZE; n++) {
		chc2+=array[n];
		if(n && array[n-1]>array[n]) break;
	}
	if(chc1!=chc2) printf("CHC error!\n\a");
	if(n<SIZE) printf("sequence error!\n\a");
	printf("size: %d\n",(int)SIZE);	//  
	printf("depth: %d\n",max_depth);	//   
	printf("sort time: %d.%ds\n",(t2-t1)/1000,((t2-t1)%1000)/10);
	system("pause");
	return 0;
}

